#/************************************************************************
# *									*
# *			Copyright (c) 1990 by     			*
# *		Digital Equipment Corporation, Maynard, MA		*
# *			All rights reserved.				*
# *									*
# *   This software is furnished under a license and may be used and	*
# *   copied  only  in accordance with the terms of such license and	*
# *   with the  inclusion  of  the  above  copyright  notice.   This	*
# *   software  or  any  other copies thereof may not be provided or	*
# *   otherwise made available to any other person.  No title to and	*
# *   ownership of the software is hereby transferred.			*
# *									*
# *   The information in this software is subject to change  without	*
# *   notice  and should not be construed as a commitment by Digital	*
# *   Equipment Corporation.						*
# *									*
# *   Digital assumes no responsibility for the use  or  reliability	*
# *   of its software on equipment which is not supplied by Digital.	*
# *									*
# *									*
# ************************************************************************
# *									*
# *			Modification History				*
# *									*
# ************************************************************************
# *									*
# * Authors:								*
# *	DBW - David B. Wecker, Database Systems Research Group	      	*
# *		DTN: 	523-2794					*
# *		PHONE:	719/260-2794					*
# *		ENET:	CHILD::WECKER					*
# *		USENET:	decwrl!child.dec.com!wecker			*
# *		ARPA:	wecker%child.dec.com@decwrl.dec.com		*
# *		MS: 	CXN/2 Upper - 564				*
# *		MAIL:	1175 Chapel Hills Drive, Col Spgs, CO 80920-3952*
# *									*
# * Versions:								*
# *  v1.0 DBW 871105 Ultrix/X10 based version				*
# *  v2.1 DBW 871117 Major re-write (non X based)			*
# *  v2.2 DBW 880114 Update of internal functions			*
# *  v3.0 DBW 881213 Major new release (replaced NeurDS compiler)	*
# *  v3.1 DBW 890501 Minor release for external use (portability fixes)	*
# *									*
# ************************************************************************/

CFLAGS  = /DEBUG/DEFINE=VMS/INCLUDE=SYS$LIBRARY
LFLAGS	= 
NC	= mcr sys$disk:[]nc
CC	= cc
LN	= link
LIBS	= sys$library:vaxcrtl/lib
OBJS	= NeurDS.obj,curses.obj,random.obj
SRCS	= NeurDS.c,curses.c,random.c,nc.c,NeurDS.h
MODELS	= bp.nc,mft.nc,bp2.nc,GM.nc
DOCS	= NeurDS_v31.ps,NeurDS.help,README.TXT,plt.help
SCRIPTS	= bp.script,mft.script,bp2.script,GM.script,GM.plt,SYMS.COM
MSCSRC	= plt.c,GlassMackey.c
MAKES	= Makefile.;,DESCRIP.MMS,Make.version
KITVER	= $(SRCS),$(MODELS),$(MSCSRC)
KITSRC  = $(KITVER),$(DOCS),$(SCRIPTS),$(MAKES)
KITDIR	= [-.-.kits]

.SUFFIXES
.SUFFIXES	.obj .c .nc

all : bp.exe mft.exe bp2.exe GM.exe plt.exe
	! "Make complete"

# Back propagation model

bp.exe : bp.obj $(OBJS)
	$(LN)$(LFLAGS)/exe=bp.exe bp.obj,$(OBJS),$(LIBS)

bp.c  : nc.exe bp.nc

# Mean field theory model

mft.exe : mft.obj $(OBJS)
	$(LN)$(LFLAGS)/exe=mft.exe mft.obj,$(OBJS),$(LIBS)

mft.c  : nc.exe mft.nc


# 2nd order Back propagation model

bp2.exe : bp2.obj $(OBJS)
	$(LN)$(LFLAGS)/exe=bp2.exe bp2.obj,$(OBJS),$(LIBS)

bp2.c  : nc.exe bp2.nc

# Back propagation model for the GlassMackey data

GM.exe : GM.obj $(OBJS) GlassMackey.exe
	$(LN)$(LFLAGS)/exe=GM.exe GM.obj,$(OBJS),$(LIBS)

GM.c  : nc.exe GM.nc

# program to generate Glass Mackey data

GlassMackey.exe : GlassMackey.obj
	$(LN)$(LFLAGS)/exe=GlassMackey.exe GlassMackey.obj,$(LIBS)
	run GlassMackey


# NeurDS Compiler definition

nc.exe : nc.obj
	$(LN)$(LFLAGS)/exe=nc.exe nc.obj,$(LIBS)


# plt utility

plt.exe : plt.obj
	$(LN) $(LFLAGS)/exe=plt.exe plt.obj,$(LIBS)


# definition of .nc to .c translation:

.nc.c :
	$(NC) $*.nc


# kit build:

#version:
#	csh -fe Make.version $(KITVER)

kit :
	backup $(KITSRC) $(KITDIR)NeurDS_v31.save/save

