/************************************************************************
 *									*
 *			Copyright (c) 1990 by     			*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 *									*
 ************************************************************************
 *									*
 *			Modification History				*
 *									*
 ************************************************************************
 *									*
 * Authors:								*
 *	DBW - David B. Wecker, Database Systems Research Group	      	*
 *		DTN: 	523-2794					*
 *		PHONE:	719/260-2794					*
 *		ENET:	CHILD::WECKER					*
 *		USENET:	decwrl!child.dec.com!wecker			*
 *		ARPA:	wecker%child.dec.com@decwrl.dec.com		*
 *		MS: 	CXN/2 Upper - 564				*
 *		MAIL:	1175 Chapel Hills Drive, Col Spgs, CO 80920-3952*
 *									*
 * Versions:								*
 *  v1.0 DBW 871105 Ultrix/X10 based version				*
 *  v2.1 DBW 871117 Major re-write (non X based)			*
 *  v2.2 DBW 880114 Update of internal functions			*
 *  v3.0 DBW 881213 Major new release (replaced NeurDS compiler)	*
 *  v3.1 DBW 890501 Minor release for external use (portability fixes)	*
 *									*
 ************************************************************************/

char	*VERSION    = 
"NeurDS version 3.1 (c) Copyright 1988, 1989 Digitial Equipment Corp -----";

#include <stdio.h>
#include <setjmp.h>
#include <signal.h>
#include <varargs.h>

#ifdef VMS
#include <stsdef.h>
#include <ssdef.h>
#include <descrip.h>
#include <iodef.h>
#include <ttdef.h>
#include <tt2def.h>
#include <msgdef.h>

#define EFN     0		/* Event flag */

int oldmode[3];		/* Old TTY mode bits */
short iochan;		/* TTY I/O channel */
#endif

#define MAIN_MODULE
#include "NeurDS.h"

extern	char *fgets(),*malloc(),*getenv();
extern	row,col;

extern	long	random();
extern		srandom();
extern	double	rnd();

#define PASSF(a)    *(long *)&(a)

#define RESCALE(v)  (MINVAL?((v+1.0)/2.0):v)

int	lookup[MAXASSOC];
char	*hexstr	    = "0123456789abcdef";
int	echo	    = 1;
int	adump	    = 0;
int	pdump	    = 0;
int	report	    = 1;
int	doplot	    = 1;
int	numplot	    = 1;
int	showdiff    = 0;
int	mix	    = 0;
int	maxloop	    = 999999;
int	canrand	    = 0;
int	forcerand   = 999999;
int	tryrand	    = 999999;
double	tryerr	    = 999999.999;

jmp_buf	env;

FILE    *inpfil[5],*outfil;
int	inpnum = 0;
#define	INPMAX	 4

FILE	*trace  = NULL;
char	str[256],cmd[256];
int	PRrow,PRcol;
int	Tlines	    = 48,
	Tlines_1    = 38,
	Tlines_2    = 40,
	Tlines_3    = 45,
	Tlines_4    = 47;

#define	Pcol_s	   50
#define Pcol_l	   30
#define	Pcol_f     29.9
#define Pcol_m	   14.9
#define Pcol_h	   65

char *defaultext(fname,ext,force) 
char *fname, *ext; int force;
    {
    static char result[255];
    char c, *point, *s = result;
    strcpy(result,fname);
    while (*s) ++s;
    point = s;
    while (c = *s, s > result && c != '.') --s;
    if (c == '.') {                                /* some extention exists */
	point = s;
	if (!force) return result;            /* don't worry about what it is */
	}
    strcpy(point,ext);                 /* put default extention after point */
    return result;
    }

PR(fmt, va_alist)
char	*fmt;
va_dcl
    {
    va_list	    ap;
    char	    str[4096];
    FILE	    strbuf;

    va_start(ap);
    vsprintf(str,fmt,ap);

    move(PRrow,PRcol);
    addstr(str);
    PRrow = row;
    PRcol = col;
    if (fmt[0] != ';') refresh();

    if (!doplot) fputs(str,outfil);

    if (trace) {
	fputs(str,trace);
	fflush(trace);
	}
    }

int	pltrow;
struct {
    char    chr;
    double   maxval,maxhrd;
    double   vals[66];
    } plotdat[10],plotdiff;

struct oldinpstr {
    struct  oldinpstr *next,*prev;
    char    *str[256];
    } *lstinpstr = NULL;

doclear() {
    clear();
    scroll(Tlines_2,Tlines_3);
    PRrow  = Tlines_2;
    PRcol  = 0;
    pltrow = 0;
    move(Tlines_2-1,0);
    standout(); addstr(SVERSION); standend();
    move(Tlines_4-1,0);
    standout(); addstr(VERSION); standend();
    plotinit();
    move(Tlines_4,0);
    addstr("> ");
    touchwin();
    }

char *INP(str,siz)
char	*str;
int	siz;
    {
    int	    i,c;
    struct  oldinpstr *curinpstr;

    if (inpfil[inpnum] == stdin && doplot) {
	curinpstr = (struct oldinpstr *)malloc(sizeof(struct oldinpstr));
	curinpstr->next	    = NULL;
	curinpstr->prev	    = lstinpstr;
	curinpstr->str[0]   = '\000';
	if (lstinpstr) lstinpstr->next = curinpstr;
	lstinpstr	    = curinpstr;
	move(Tlines_4,0);
	clrtoeol();
	addstr("> ");
	refresh();
	for (i=0; i < siz; i++) {
	    c = ttgetc();
	    if (c == '\r' || c == '\n') break;
	    switch (c) {
		case 0x7f:  /* delete ^? */
		case 0x8:   /* backspace ^H */
		if (col > 2) { col--; i--; }
		clrtoeol();
		i--;
		break;

		case 0x6:   /* forward a line ^F */
		i--;
		if (!curinpstr->next) break;
		curinpstr = curinpstr->next;
		strcpy(str,curinpstr->str);
		col = 2;
		i   = strlen(str)-1;
		addstr(str);
		clrtoeol();
		break;

		case 0x12:  /* reverse a line ^R */
		i--;
		if (!curinpstr->prev) break;
		curinpstr = curinpstr->prev;
		strcpy(str,curinpstr->str);
		col = 2;
		i   = strlen(str)-1;
		addstr(str);
		clrtoeol();
		break;

		case 0x15:  /* erase line ^U */
		col = 2;
		i   = -1;
		clrtoeol();
		break;

		case 0xC:   /* clear screen ^L */
		doclear();
		i--;
		break;

		case 0x17:  /* repaint ^W */
		touchwin();
		i--;
		break;

		default:
		addchr(c);
		str[i] = (char)c;
		break;
		}
	    refresh();
	    }
	str[i]   = '\000';
	strcpy(lstinpstr->str,str);
	str[i++] = '\n';
	str[i]   = '\000';
	return str;
	}
    else {
	if (inpfil[inpnum] == stdin) {
	    fprintf(outfil,"> ");
	    fflush(outfil);
	    }
	return fgets(str,siz,inpfil[inpnum]);
	}
    }

plotinit()
    {
    int	    i;

    for (i=0; i<10; i++) {
	plotdat[i].maxval = -10000.0;
	plotdat[i].maxhrd = -10000.0;
	}
    plotdiff.maxval = -10000.0;
    pltrow = 0;
    for (i=0; i<=Tlines_1; i++) {
	move(i,0);
	clrtoeol();
	}
    standout();
    for (i=0; i<=Tlines_1; i++) {
	move(i,Pcol_s-1);
	addchr('|');
	}
    standend();
    }

char	*p1str = "-zyxwvutsrqponmlkjihgfedcba.ABCDEFGHIJKLMNOPQRSTUVWXYZ+";
char	*p2str = "00000---.+++11111";
plotval(r,c,s,v)
int	r,c,s;
double	v;
    {
    int	    i;
    char    chr;

    if (r > Tlines_1)	return;
    if (c >= Pcol_s)	return;
    if (r) {
	i = (int)(54.99 *  v);
	if (i > 54) i = 54;
	if (i <  0) i = 0;
	chr = p1str[i];
	}
    else {
	i = (int)(v * 16.99);
	if (i > 16) i = 16;
	if (i <  0) i = 0;
	chr = p2str[i];
	}
    if (s) standout();
    move(r,c);
    addchr(chr);
    if (s) standend();
    }

plotlnks() {
    int	    l,base;
    UNIT    *u1;
    LINK    *lnk;
    double   max,min;

    max = -99999.9;
    min =  99999.9;
    for (l = 1; l <= OUTPUT; l++)
	for (u1 = networks[l]; u1; u1 = u1->next) {
	    plotval(0,u1->nn,1-(l&1),RESCALE(u1->val));
	    if (l == 1) base = u1->nn;
	    for (lnk = u1->out; lnk; lnk = lnk->outnxt) {
		if (lnk->weight > max) max = lnk->weight;
		if (lnk->weight < min) min = lnk->weight;
		}
	    }
    if (-min > max) max = -min;
    if (max == 0.0) max = 1.0;
    max *= 2.0;
    for (l = 1; l <= OUTPUT; l++)
	for (u1 = networks[l]; u1; u1 = u1->next) {
	    for (lnk = u1->out; lnk; lnk = lnk->outnxt)
		plotval(lnk->out->nn-base,u1->nn,1-(l&1),0.5+(lnk->weight/max));
	    }
    for (u1=networks[0]; u1; u1 = u1->next)
	plotval(0,u1->nn,1-(l&1),RESCALE(u1->val));
    }

plot(n,val)
int	n;
double	val;
    {
    int	    r,c,redo;

    redo = 0;
    if (val < 0.0) val = 0.0;
    if (val > plotdat[n].maxval) { plotdat[n].maxval = val * 1.2; redo = 1; }
    if (plotdat[n].maxval == 0.0) plotdat[n].maxval = 0.001;
    if (pltrow == 0) plotdat[n].maxhrd = val * 1.2;
    if (plotdat[n].maxhrd == 0.0) plotdat[n].maxhrd = 0.001;
    plotdat[n].vals[pltrow] = val;
    if (showdiff) return;
    if (!redo) {
	c = (int)(Pcol_f * val / plotdat[n].maxval);
	move(pltrow,Pcol_s+c);
	if (inch() == ' ')  addchr(PLOTCHAR[n]);
	else		    addchr('*');
	return;
	}
    for (r=0; r <= Tlines_1; r++) {
	move(r,Pcol_s);
	clrtoeol();
	}
    for (n=0; n<10; n++) {
	if (!PLOTCHAR[n]) break;
	for (r=0; r <= pltrow; r++) {
	    c = (int)(Pcol_f * plotdat[n].vals[r] / plotdat[n].maxval);
	    move(r,Pcol_s+c);
	    if (inch() == ' ')	addchr(PLOTCHAR[n]);
	    else		addchr('*');
	    }
	}
    }

plotind(row,val)
int	row;
double	val;
    {
    int	    r,c,redo;
    double   absval;
    
    if (row >= Tlines_1) return;
    if (val < 0.0)  absval = -val;
    else	    absval =  val;
    redo = 0;
    if (absval > plotdiff.maxval) { plotdiff.maxval = absval * 1.2; redo = 1; }
    if (plotdiff.maxval == 0.0) plotdiff.maxval = 0.001;
    plotdiff.vals[row] = val;
    for (r=redo?0:row; r <= row; r++) {
	move(r,Pcol_s);
	clrtoeol();
/*
	move(r,Pcol_h);
	addchr('|');
	c = (int)(Pcol_m * plotdiff.vals[r] / plotdiff.maxval);
	if (c < 0) {
	    move(r,Pcol_h+c);
	    c = -c;
	    }
	else move(r,Pcol_h+1);
*/
	if (plotdiff.vals[r] < 0.0) val = -plotdiff.vals[r];
	else			    val =  plotdiff.vals[r];
	c = (int)(Pcol_f * val / plotdiff.maxval);

	while (c--) addchr('#');
	}
    }

plotupd() {
    int	    i,r,c,n;
    char    genbuf[81],linebuf[81];

    if (trace || !doplot) {
	for (i=0; i<80; i++) genbuf[i] = ' ';
	for (n=0; n<10; n++) {
	    if (!PLOTCHAR[n]) break;
	    c = (int)(76.9 * plotdat[n].vals[pltrow] / plotdat[n].maxhrd) + 1;
	    if (c > 76) c = 76;
	    if (c < 1)  c = 1;
	    if (genbuf[c] == ' ')   genbuf[c] = PLOTCHAR[n];
	    else		    genbuf[c] = '*';
	    }
	genbuf[0]  = ';';
	genbuf[77] = '\000';
	tabify(genbuf,linebuf);
	if (!doplot)	fprintf(outfil,"%s\n",linebuf);
	if (trace)	{ fprintf(trace, "%s\n",linebuf); fflush(trace); }
	}
    plotlnks();
    if (pltrow++ < Tlines_1) {
	refresh();
	return;
	}
    pltrow = 5;
    for (n=0; n<10; n++) {
	if (!PLOTCHAR[n]) break;
	for (r=0; r<5; r++)
	    plotdat[n].vals[r] = plotdat[n].vals[r+Tlines_1-4];
	plotdat[n].maxval   = -10000;
	for (r=0; r < pltrow; r++) {
	    if (plotdat[n].vals[r] > plotdat[n].maxval) 
		plotdat[n].maxval = plotdat[n].vals[r];
	    }
	plotdat[n].maxval *= 1.2;
    	if (plotdat[n].maxval == 0.0) plotdat[n].maxval = 0.001;
	if (showdiff) continue;
	if (!n)	for (r=0; r<=Tlines_1; r++) { move(r,Pcol_s); clrtoeol(); }
	for (r=0; r < pltrow; r++) {
	    c = (int)(Pcol_f * plotdat[n].vals[r] / plotdat[n].maxval);
	    move(r,Pcol_s+c);
	    if (inch() == ' ')  addchr(PLOTCHAR[n]);
	    else		addchr('*');
	    }
	}
    refresh();
    }

bldhex(str,val)
char	*str;
int	val;
    {
    char    sstr[256];

    sstr[0] = hexstr[val];
    sstr[1] = '\000';
    if (strlen(str) < 254) {
    	strcat(sstr,str);
    	strcpy(str,sstr);
    	}
    }

dump(msg,amount)
char	*msg;
int	amount;
    {
    int	    i,j,k,l1,shft,retval,bit1,bit2;
    char    istr[256],ostr[256],tstr[256],sstr[256];
    UNIT    *u1,*u2;
    LINK    *lnk;

    if (amount == 4) {
	PR("; Dumping screen:\n");
	for (i=0; i<Tlines; i++) {
	    move(i,0);
	    inrow(1,sstr);
	    tabify(sstr,tstr);
	    if (!doplot) fprintf(outfil,"%s",tstr);
	    if (trace)   fprintf(trace,"%s",tstr);
	    }
	return;
	}
	    
    if (amount >= 0) {
	i	= 0;
	shft    = 0;
	istr[0] = '\000';
	for (u1 = networks[1]; u1 != NULL; u1 = u1->next) {
	    if (CONTINUOUS) {
		sprintf(sstr,"%5.3lf ",u1->val);
		if (strlen(istr)+6 < 255) strcat(istr,sstr);
		}
	    else {
		if (RESCALE(u1->val) > 0.5) i |= (1 << shft);
		if (shft++ == 3) {
		    bldhex(istr,i);
		    i	 = 0;
		    shft = 0;
		    }
		}
	    }
	if (shft) bldhex(istr,i);
	}
    j	    = 0;
    k	    = 0;
    shft    = 0;
    ostr[0] = '\000';
    tstr[0] = '\000';
    retval  = 0;
    for (u1=networks[OUTPUT],u2=networks[0];u1!=NULL;u1=u1->next,u2=u2->next) {
	if (CONTINUOUS) {
	    sprintf(sstr,"%5.3lf ",u1->val);
	    if (strlen(ostr)+6 < 255) strcat(ostr,sstr);
	    sprintf(sstr,"%5.3lf ",u2->val);
	    if (strlen(tstr)+6 < 255) strcat(tstr,sstr);
	    }
	else {
	    bit1 = bit2 = 0;
	    if (RESCALE(u1->val) > 0.5) { j |= (1 << shft); bit1 = 1; }
	    if (RESCALE(u2->val) > 0.5) { k |= (1 << shft); bit2 = 1; }
	    if (bit1 != bit2) retval++;
	    if (shft++ == 3) {
		if (amount >= 0) { bldhex(ostr,j); bldhex(tstr,k); }
		j	    = 0;
		k	    = 0;
		shft    = 0;
		}
	    }
	}
    if (shft) {
	if (amount >= 0) { bldhex(ostr,j); bldhex(tstr,k); }
	}

    if (amount == -1) return(retval);
    plotlnks();
    refresh();
    if (amount == 0 && echo)
	PR(";%s\tOutput: %s\n",msg,ostr);
    else {
	PR(";%s\tInput: %s Output: %s (%s)",msg,istr,ostr,tstr);
	if (retval) PR(" (%d bits bad)",retval);
	PR("\n");
	}

    if (amount == 0) return(retval);
    PR(";==================================================================\n");
    PR("params %8.3lf %8.3lf %8.3lf %8.3lf %8.3lf\n",A1,A2,A3,A4,A5);
    PR(";------------------------------------------------------------------\n");
    for (l1 = 1; l1 <= OUTPUT; l1++) {
	PR(";Level %2d:",l1);
	i = 0;
	for (u1 = networks[l1]; u1 != NULL; u1 = u1->next) {
	    PR(" %7.3lf",u1->val);
	    if ((++i % 8) == 0) PR("\n;\t  ");
	    }
	PR("\n");
	}
    PR(";Target  :");
    i = 0;
    for (u1 = networks[0]; u1 != NULL; u1 = u1->next) {
	PR(" %7.3lf",u1->val);
	if ((++i % 8) == 0) PR("\n;\t ");
	}
    PR("\n");
    PR(";------------------------------------------------------------------\n");
    if (amount == 1) return(retval);
    for (l1 = 1; l1 <= OUTPUT; l1++) {
	for (j=0,u1 = networks[l1]; u1 != NULL; u1 = u1->next,j++) {
	    PR(";\tUnit %2d,%2d\t",l1,u1->id);
	    PR("val %11.6f err %11.6lf\n",u1->val,u1->err);
	    }
	if (l1 == OUTPUT) PR("unit\t%d,%d*\n",l1,j);
	else		  PR("unit\t%d,%d\n",l1,j);
	}
    PR(";------------------------------------------------------------------\n");
    if (amount == 2) return(retval);
    for (l1 = 1; l1 <= OUTPUT; l1++) {
	for (u1 = networks[l1]; u1 != NULL; u1 = u1->next)
	    for (lnk = u1->out; lnk != NULL; lnk = lnk->outnxt)
		PR("link\t%d,%d %d,%d %11.6lf %11.6lf\n",l1,u1->id,
		    lnk->out->level,lnk->out->id,lnk->weight,lnk->cweight);
	if (networks[l1] && networks[l1]->out) PR(";\n");
	}
    PR(";------------------------------------------------------------------\n");
    return(retval);
    }

error(leave,msg,a1,a2,a3,a4)
int	leave;
char	*msg,*a1,*a2,*a3,*a4;
    {
    if (msg != NULL) {
	PR(";\n;ERROR: ");
	PR(msg,a1,a2,a3,a4);
	PR("\n");
	if (inpfil[inpnum] == stdin)
	    PR(";      Type `help' for more information\n");
	PR(";\n");
	}
    if (leave || inpfil[inpnum] != stdin || !doplot) {
	endwin();
	if (trace)			fclose(trace);
	if (outfil)			fclose(outfil);
	while (inpnum)			fclose(inpfil[inpnum--]);
	if (inpfil[inpnum] &&
	    inpfil[inpnum] != stdin)	fclose(inpfil[inpnum]);
#	ifdef VMS
	    exit(1);
#	else
	    exit(0);
#	endif
	}
    }

UNIT *rndunit(level,u1)
int	level;
UNIT	*u1;
    {
    while (1) {
	if (!u1) u1 = networks[level];
	if (rnd() > .7) return u1;
	u1 = u1->next;
	}
    }

randomize(full,first,last,base,range,lbase,lrange)
double	base,range,lbase,lrange;
    {
    int	    i;
    UNIT    *u1;
    LINK    *lnk;

    for (i=first; i <= last; i++) {
	for (u1 = networks[i]; u1 != NULL; u1 = u1->next) {
	    u1->sum	 = 0.0;
	    u1->val	 = base + (rnd() * range);

	    if (full) {
		for (lnk = u1->out; lnk != NULL; lnk = lnk->outnxt) {
		    lnk->weight = lbase + (rnd() * lrange);
		    }
		}
	    }
	}
    }

getbit(str,bit)
char	*str;
int	bit;
    {
    int	    i,j,x;

    i = bit % 4;
    j = bit / 4;
    j = strlen(str)-(j+1);
    if (j < 0) return 0;
    sscanf(&str[j],"%1x",&x);
    return (x & (1<<i));
    }


do_pat(j,mode) {
    char    *iptr;
    int	    i;
    UNIT    *u1;

    iptr = inppat[lookup[j]][0];
    for (i=0,u1 = networks[1]; u1 != NULL; u1 = u1->next,i++)
	u1->val = (getbit(iptr,i)) ? 1.0 : (MINVAL?-1.0:0.0);
    iptr = inppat[lookup[j]][1];
    for (i=0,u1=networks[0]; u1 != NULL; u1 = u1->next,i++)
	u1->val = (getbit(iptr,i)) ? 1.0 : (MINVAL?-1.0:0.0);
    }

/* mode 0 = run, 1 = learn, 2 = run/nostats, 3 = dump patterns */
int	loop  = 0;

trypats(mode)
int	mode;
    {
    int	    i,j,k,l,good,esav;
    UNIT    *u1;
    char    scr[40];

    good     = 0;
    for (i=inpmin; i<inpmax; i++) lookup[i] = i;
    if (mode == 1 && mix) {	   
	for (i=inpmin; i<inpmax; i++) {
	    j = inpmin + (random() % inpcnt);
	    k = inpmin + (random() % inpcnt);
	    l = lookup[j];
	    lookup[j] = lookup[k];
	    lookup[k] = l;
	    }
	}
    if (mode == 3) { 
	esav = echo;
	echo = 0;
	}
    for (j=inpmin; j < inpmax; j++) {
	SIM_PAT(lookup[j],mode);

	if ((i=SIM_RUN(mode))) good++;
	if (mode != 1) {
	    if (mode == 0 && showdiff) plotind(j,OUTERR);
	    if (mode == 3) dump(" ",0);
	    }
	else {
	    if (showdiff)	plotind(j,OUTERR);

	    if (pdump && (loop % numplot) == 0) {
		plotlnks();
		refresh();
		}
	    if (adump && (loop % report) == 0) {
		sprintf(scr,"Error %11.6lf",OUTERR);
		dump(scr,0);
		}
	    if (i)  SIM_LEARN(0);
	    else    SIM_LEARN(1);
	    }
	}

    if (mode == 1) SIM_LPASS(loop,inpcnt);
    if (mode == 3) echo = esav;

    return good;
    }

assoc()
    {
    int	    i,j,l1,good,frloop,trloop;
    UNIT    *u1;
    long    delta;
    double   toterr,SIM_REPORT(),preverr = 9999.9;

    SIM_LINIT();

    /* set up row id's for plotting */
    for (i=0,l1 = 1; l1 <= OUTPUT; l1++)
	for (u1 = networks[l1]; u1; u1 = u1->next)
	    u1->nn = i++;
    for (u1=networks[0]; u1; u1=u1->next) u1->nn = i++;

    good    = 0;
    loop    = 0;
    frloop  = 1;
    trloop  = 1;
    preverr = 0.0;
    delta   = 1;
    while (good != inpcnt) {
	if (loop++ >= maxloop) break;

	good = trypats(1);
	if (good == inpcnt) good = trypats(2);
	if ((loop % numplot) == 0) {
	    SIM_PLOT(inpcnt);
	    plotupd();
	    }

	if ((loop % report)  == 0) {
	    toterr = SIM_REPORT(loop,inpcnt);
	    delta = (long)(1000000 * (toterr - preverr));
	    preverr = toterr;

	    if (good != inpcnt && delta == 0) {
		if (canrand == 0) {
		    PR(";\t<<<< AT DEAD END >>>>\n");
		    break;
		    }
		else if (canrand == 1) {
		    PR(";\t<<<< DEADEND: FORCING RANDOMIZATION OF NET >>>>\n");
		    SIM_RAND();
		    SIM_LINIT();
		    preverr = 0.0;
		    frloop = 0;
		    trloop = 0;
		    delta  = 1;
		    }
		}
	    }
	if (good != inpcnt && canrand == 1) {
	    if (frloop++ == forcerand) {
		PR(";\t<<<< FORCE:   FORCING RANDOMIZATION OF NET >>>>\n");
		SIM_RAND();
		SIM_LINIT();
		preverr = 0.0;
		frloop = 1;
		trloop = 1;
		delta  = 1;
		}
	    else if (trloop++ == tryrand && toterr > tryerr) {
		PR(";\t<<<< ERRLEV:  FORCING RANDOMIZATION OF NET (%.3lf > %.3lf) >>>>\n",
		    toterr,tryerr);
		SIM_RAND();
		SIM_LINIT();
		preverr = 0.0;
		frloop = 1;
		trloop = 1;
		delta  = 1;
		}
	    }
	}
    plotlnks();
    refresh();
    SIM_LEND(loop);
    trypats(3);
    }

getterm() {
    char    *name,bp[1024],*getenv();
    int	    i;

#if VMS
    struct dsc$descriptor  idsc;
    struct dsc$descriptor  odsc;
    char oname[40];
    int iosb[2];
    int status;

    Tlines = 24;
    odsc.dsc$a_pointer = "TT";
    odsc.dsc$w_length = strlen(odsc.dsc$a_pointer);
    odsc.dsc$b_dtype = DSC$K_DTYPE_T;
    odsc.dsc$b_class = DSC$K_CLASS_S;
    idsc.dsc$b_dtype = DSC$K_DTYPE_T;
    idsc.dsc$b_class = DSC$K_CLASS_S;
    do {
	idsc.dsc$a_pointer = odsc.dsc$a_pointer;
	idsc.dsc$w_length = odsc.dsc$w_length;
	odsc.dsc$a_pointer = &oname[0];
	odsc.dsc$w_length = sizeof(oname);
	status = LIB$SYS_TRNLOG(&idsc, &odsc.dsc$w_length, &odsc);
	if (status!=SS$_NORMAL && status!=SS$_NOTRAN) goto GIVEUP;
	if (oname[0] == 0x1B) {
	    odsc.dsc$a_pointer += 4;
	    odsc.dsc$w_length -= 4;
	    }
	}
    while (status == SS$_NORMAL);
    status = SYS$ASSIGN(&odsc, &iochan, 0, 0);
    if (status != SS$_NORMAL) goto GIVEUP;
    status = SYS$QIOW(EFN, iochan, IO$_SENSEMODE, iosb, 0, 0,
	oldmode, sizeof(oldmode), 0, 0, 0, 0);
    if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL) goto GIVEUP;
    Tlines = (oldmode[1] >> 24) & 0xFF;
    status = SYS$DASSGN(iochan);

GIVEUP:

#else
    Tlines = 24;
    if (!(name=getenv("TERM"))) return;
    if (tgetent(bp,name) != 1) return;
    if ((i=tgetnum("li")) == -1) return;
    Tlines   = i;
#endif

    Tlines_4 = Tlines - 1;
    Tlines_3 = Tlines - 3;
    Tlines_2 = Tlines_3 - 5;
    Tlines_1 = Tlines_2 - 2;
    }

handler() {
    signal(SIGINT,handler);
    PR(";\n;\007!!!! ^C intercepted, use 'exit' to leave (^W to repaint) !!!!\007\n");
    longjmp(env,1);
    }
    
main(argc,argv)
int argc;
char *argv[];
    {
    int	    l1;

    signal(SIGINT,handler);

    inpfil[inpnum] = stdin;
    outfil = stdout;
    while (argc > 1 && *argv[1] == '-')  {
	switch (argv[1][1]|' ') {
	    case 'p':	doplot = 0; break;
	    default:	error(1,"Unknown switch\n");;
	    }
	--argc; ++argv;
	}
    if (argc > 1) {
	if ((inpfil[inpnum] = fopen(defaultext(argv[1],".script",0),"r"))
		 == NULL)
	    error(1,"Can't open input file");
	}
    if (argc > 2) {
	if ((outfil = fopen(defaultext(argv[2],".trace",0),"w")) == NULL)
	    error(1,"Can't open output file");
	doplot = 0;
	}

    if (doplot) getterm();
    initscr(doplot,"NeurDS screen");
    resize(Tlines,80);
    clear();
    scroll(Tlines_2,Tlines_3);
    PRrow = Tlines_2;
    PRcol = 0;
    plotinit();

    SIM_INIT();
    if (!doplot) PR("; %s\n; %s\n\n",VERSION,SVERSION);
    move(Tlines_2-1,0);
    standout(); addstr(SVERSION); standend();
    move(Tlines_4-1,0);
    standout(); addstr(VERSION); standend();
    refresh();

    /* get the input net description file */
    /* zero out the network */
    for (l1 = 0; l1 < MAXNETS; l1++) networks[l1] = NULL;

    /* read in the commands */
    while (1) {
	if (setjmp(env)) {
	    if (inpnum) {
		while (inpnum) fclose(inpfil[inpnum--]);
		}
	    if (inpfil[inpnum] != stdin)
		error(1,"Exiting due to lack of terminal at top level");
	    }
	if (INP(str,256) == NULL) {
	    if (inpnum) {
		fclose(inpfil[inpnum--]);
		continue;
		}
	    break;
	    }
	docmd();
	}

    /* all done */
    error(1,NULL);
    }

docmd()
    {
    int	    i,j,k,l,l1,l2;
    UNIT    *u1,*u2;
    LINK    *lnk,*lnk2;
    double   weight,cweight;
    char    chr;

    if (echo) {
	if (str[0] == ';') PR("%s",str);
	else	       PR(";%s",str);
	}
    if (sscanf(str,"%s",cmd) != 1 || cmd[0] == ';') return;
    switch (cmd[0]|' ') {
        case 'a': /********  assoc  ********/
	sscanf(str,"%s %d %d %d %d %d %d %lf",
		cmd,&inpmin,&inpcnt,&maxloop,&canrand,
		&forcerand,&tryrand,&tryerr);
	inpmax = inpmin + inpcnt;
	if (OUTPUT == 0) {
	    error(0,"No OUTPUT layer defined");
	    break;
	    }
	assoc();
	break;

	case 'c': /********  clear  ********/
	for (l1 = 0; l1 <= OUTPUT; l1++) {
	    u2 = NULL;
	    for (u1 = networks[l1]; u1 != NULL; u1 = u1->next) {
		if (u2 != NULL) free(u2);
		lnk2 = NULL;
		for (lnk = u1->out; lnk != NULL; lnk = lnk->outnxt) {
		    if (lnk2 != NULL) free(lnk2);
		    lnk2 = lnk;
		    }
		if (lnk2 != NULL) free(lnk2);
		u2 = u1;
		}
	    if (u2 != NULL) free(u2);
	    networks[l1] = NULL;
	    }
	OUTPUT = 0;
	doclear();
	refresh();
	break;

	case 'd': /********  dump  ********/
	if (sscanf(str,"%s %d",cmd,&i) != 2) {
	    error(0,"Wrong number of parameters to dump command");
	    break;
	    }
	dump("Dump:",i);
	break;

	case 'e': /********  exit  ********/
	error(1,NULL);
	break;

	case 'h': /********  help   ********/
	move(Tlines_3,0);
	refresh();
	spush();
#ifdef VMS
	system("type/page NeurDS.help");
#else
	system("more -20 NeurDS.help");
#endif
	touchwin();
	spop();
	refresh();
	break;

	case 'i': /********  input  ********/
	sscanf(str,"%s %d %d",cmd,&inpmin,&inpcnt);
	inpmax = inpmin + inpcnt;
	trypats(3);
	break;

	case 'l': /********  link  ********/
	i = sscanf(str,"%s %d,%d %d,%d %lf",cmd,&l1,&j,&l2,&k,&weight);
	if (i < 4) {
	    i = sscanf(str,"%s %d %d",cmd,&l1,&l2);
	    if (i != 3) error(0,"Bad link command");
	    }
	u1  = networks[l1];
	if (i > 3) while (j-- && u1 != NULL) u1 = u1->next;
	u2  = networks[l2];
	if (i > 4) while (k-- && u2 != NULL) u2  = u2->next;
	if (u1 == NULL || u2 == NULL)
	    error(0,"Either from or to link missing");
	while (u1) {
	    if (i == 3 && l1 == l2) u2 = u1->next;
	    while (u2) {
		lnk = u1->out;
		while (lnk && lnk->out != u2) lnk = lnk->outnxt;
		if (!lnk) {
		    lnk = (LINK *)malloc(sizeof(LINK));
		    lnk->cweight    = 0.0;
		    lnk->inp	= u1;
		    lnk->out	= u2;
		    lnk->inpnxt	= NULL;
		    lnk->outnxt	= NULL;
		    if (u1->out == NULL) u1->out = lnk;
		    else {
			lnk2	    = u1->out;
			while (lnk2->outnxt != NULL) lnk2 = lnk2->outnxt;
			lnk2->outnxt = lnk;
			}
		    if (u2->inp == NULL) u2->inp = lnk;
		    else {
			lnk2	    = u2->inp;
			while (lnk2->inpnxt != NULL) lnk2 = lnk2->inpnxt;
			lnk2->inpnxt  = lnk;
			}
		    }
		if (i > 5)	{
		    lnk->weight = weight;
		    break;
		    }
		else lnk->weight = (2.0 * rnd()) - 1.0;
		if (i > 4) break;
		u2 = u2->next;
		}
	    if (i > 3) break;
	    u1 = u1->next;
	    u2  = networks[l2];
	    }
	break;

	case 'p': /********  params  ********/
	i = sscanf(str,"%s %f %f %f %f %f",
		cmd,&A1,&A2,&A3,&A4,&A5);
	if (i != 6) error(0,"Bad format for params command");
	break;

	case 'r': /********  randomize  ********/
	SIM_RAND();
	break;
		
	case 's': /********  script  ********/
	if (inpnum >= INPMAX) {
	    error(0,"Too many script files");
	    break;
	    }
	i = sscanf(str,"%s %s",cmd,cmd);
	if (i != 2) {
	    error(0,"Too few params on script command");
	    break;
	    }
	if ((inpfil[++inpnum] = fopen(defaultext(cmd,".script",0),"r"))
		    == NULL) {
	    --inpnum;
	    error(0,"Can't open script file");
	    break;
	    }
	break;

	case 't': /********  trace  ********/
	i = sscanf(str,"%s %s",cmd,cmd);
	if (i != 2 && !trace) {
	    error(0,"Must specify a filename to start a trace");
	    break;
	    }
	j = time(0);
	if (trace) {
	    PR(";;;; TRACE ENDED AT: %s\n",ctime(&j));
	    fclose(trace);
	    trace = NULL;
	    }
	if (i == 2) {
	    if ((trace = fopen(defaultext(cmd,".log",0),"w")) == NULL) {
		error(0,"Can't open trace file");
		break;
		}
	    PR(";;;; TRACE STARTED AT: %s",ctime(&j));
	    }
	break;

	case 'u': /********  unit  ********/
	i = sscanf(str,"%s %d,%d%c",cmd,&l1,&j,&chr);
	if (i < 4) {
	    error(0,"Wrong number of params on unit command");
	    break;
	    }

	if (chr == '*') { 
	    k	= 1; 
	    OUTPUT	= l1;
	    }
	else k = 0;

	while(j--) {
	    for (l=0; l<=k; l++) {
		u2 = NULL;
		for (i=0,u1 = networks[l?0:l1];
			u1 != NULL;
			u1 = u1->next,i++) u2 = u1;
		u1 = (UNIT *)(malloc(sizeof(UNIT)));
		if (u2 == NULL) networks[l?0:l1] = u1;
		else	    u2->next         = u1;
		u1->next = NULL;
		u1->out  = NULL;
		u1->inp  = NULL;
		u1->sum  = 0.0;
		u1->val  = rnd();
		if (MINVAL) {
		    u1->val *= 2.0;
		    u1->val -= 1.0;
		    }
		u1->err  = 0.0;
		u1->csum = 0.0;
		u1->cval = 0.0;
		u1->cerr = 0.0;
		u1->level= l1;
		u1->id   = i;
		}
	    }
	break;

	case 'v': /********  verbose  ********/
	i = sscanf(str,"%s %d %d %d %d %d %d %d",
		cmd,&echo,&report,&numplot,&adump,&pdump,&showdiff,&mix);
	if (i<2) error(0,"Wrong number of params for verbose");
	break;

	case '0':   /* pattern load */
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	i = sscanf(str,"%d",&j);
	if (j < 0 || j >= MAXASSOC) {
	    error(0,"Pattern index not legal");
	    break;
	    }
	i = sscanf(str,"%d %s %s",&j,inppat[j][0],inppat[j][1]);
	if (i != 3) error(0,"Pattern not complete");
	if (j >= inpmax) inpmax = j + 1;
	break;

	default:
	error(0,"Unknown command");
	break;
	}
    }
