/************************************************************************
 *									*
 *			Copyright (c) 1990 by     			*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 *									*
 ************************************************************************
 *									*
 *			Modification History				*
 *									*
 ************************************************************************
 *									*
 * Authors:								*
 *	DBW - David B. Wecker, Database Systems Research Group	      	*
 *		DTN: 	523-2794					*
 *		PHONE:	719/260-2794					*
 *		ENET:	CHILD::WECKER					*
 *		USENET:	decwrl!child.dec.com!wecker			*
 *		ARPA:	wecker%child.dec.com@decwrl.dec.com		*
 *		MS: 	CXN/2 Upper - 564				*
 *		MAIL:	1175 Chapel Hills Drive, Col Spgs, CO 80920-3952*
 *									*
 * Versions:								*
 *  v1.0 DBW 871105 Ultrix/X10 based version				*
 *  v2.1 DBW 871117 Major re-write (non X based)			*
 *  v2.2 DBW 880114 Update of internal functions			*
 *  v3.0 DBW 881213 Major new release (replaced NeurDS compiler)	*
 *  v3.1 DBW 890501 Minor release for external use (portability fixes)	*
 *									*
 ************************************************************************/


#ifdef MAIN_MODULE
#   define MAINDEF
#   define MAINVAL(a)	= (a)
#else
#   define MAINDEF extern
#   define MAINVAL(a)
#endif

MAINDEF char *SVERSION 
MAINVAL("------------------------< unknown version >------------------------------");

MAINDEF char *PLOTCHAR MAINVAL("1234567890");

#ifndef NULL
#   define	NULL	    (void *)0
#endif

#define MAXNETS	    32
#define MAXASSOC    5001

typedef struct unit {
    struct unit	*next;
    struct link *out;
    struct link *inp;
    float	sum;
    float	val;
    short	id;
    short	level;
    short	nn;
    short	pad;
    float	err;
    float	csum;
    float	cval;
    float	cerr;
    } UNIT;

typedef struct link {
    struct link	*inpnxt;
    struct unit *inp;
    struct link	*outnxt;
    struct unit *out;
    float	weight;
    float	cweight;
    } LINK;

#define	TARGET	0
#define INPUT   1
#define HIDDEN	2
MAINDEF UNIT 
    *networks[MAXNETS],
    *NC_u1,
    *NC_u2;
MAINDEF LINK 
    *NC_l1;
MAINDEF float
    A1		MAINVAL(0.5),  /* learnrate */
    A2		MAINVAL(0.0),
    A3		MAINVAL(0.0),
    A4		MAINVAL(0.9),  /* momentum */
    A5		MAINVAL(0.0),  /* second order term */
    OUTERR	MAINVAL(0.0);  /* output error */
MAINDEF int
    OUTPUT	MAINVAL(0),  /* last network in system */
    MINVAL	MAINVAL(0),  /* minimum output value (0 = 0.0 1 = -1.0) */
    CONTINUOUS	MAINVAL(0),  /* using continuous neurons */
    inpmin	MAINVAL(0),  /* first pattern to use */
    inpcnt	MAINVAL(1),  /* number of patterns to learn */
    inpmax	MAINVAL(1);  /* inpmin + inpcnt */
MAINDEF char 
    inppat[MAXASSOC][2][256];
