/************************************************************************
 *									*
 *			Copyright (c) 1990 by     			*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 *									*
 ************************************************************************
 *									*
 *			Modification History				*
 *									*
 ************************************************************************
 *									*
 * Authors:								*
 *	DBW - David B. Wecker, Database Systems Research Group	      	*
 *		DTN: 	523-2794					*
 *		PHONE:	719/260-2794					*
 *		ENET:	CHILD::WECKER					*
 *		USENET:	decwrl!child.dec.com!wecker			*
 *		ARPA:	wecker%child.dec.com@decwrl.dec.com		*
 *		MS: 	CXN/2 Upper - 564				*
 *		MAIL:	1175 Chapel Hills Drive, Col Spgs, CO 80920-3952*
 *									*
 * Versions:								*
 *  v1.0 DBW 871105 Ultrix/X10 based version				*
 *  v2.1 DBW 871117 Major re-write (non X based)			*
 *  v2.2 DBW 880114 Update of internal functions			*
 *  v3.0 DBW 881213 Major new release (replaced NeurDS compiler)	*
 *  v3.1 DBW 890501 Minor release for external use (portability fixes)	*
 *									*
 ************************************************************************/

/****************************************************************************
 * New NeurDS Compiler (nc)
 ****************************************************************************/

#include <stdio.h>

#define	WHITE	    0
#define	COMMENT_S   1
#define COMMENT_E   2
#define QUOTE	    3
#define	ALPHA	    4
#define NUMERIC	    5
#define OTHER	    6
#define FIELD_L	    7
#define FIELD_C	    8
#define FIELD_R	    9

char	line[256],
	token[256],
	idname[256],
	wspace[256],
	prev[256],
	*wp	    = wspace,
	*lp	    = line;
int	lnum	    = 0;
int	toktyp,wtyp,ftyp;
FILE	*ifp = NULL,*ofp = NULL;

leave(msg,a1,a2,a3,a4)
char	*msg,*a1,*a2,*a3,*a4;
    {
    if (ifp)	fclose(ifp);
    if (ofp)	fclose(ofp);
    if (msg) {
	fprintf(stderr,"\n\n****NC line %d: ",lnum);
	fprintf(stderr,msg,a1,a2,a3,a4);
	fprintf(stderr,"\n");
#	ifdef VMS
	    exit(0);
#	else
	    exit(1);
#	endif
	}
#   ifdef VMS
	exit(1);
#   else
	exit(0);
#   endif
    }

char *defaultext(fname,ext,force) 
char *fname, *ext; int force;
    {
    static char result[255];
    char c, *point, *s = result;
    strcpy(result,fname);
    while (*s) ++s;
    point = s;
    while (c = *s, s > result && c != '.') --s;
    if (c == '.') {                                /* some extention exists */
	point = s;
	if (!force) return result;            /* don't worry about what it is */
	}
    strcpy(point,ext);                 /* put default extention after point */
    return result;
    }

getline(force) {
    if (line[0] == '\0') leave(NULL);
    if (!fgets(line,256,ifp)) {
	if (force) leave(NULL);
	else line[0] = '\0';
	}
    lnum++;
    lp = line;
    }

typ() {
    if (*lp == ' ' || *lp == '\t' || *lp == '\014' || *lp == '\n') return WHITE;
    if (*lp == '/' && *(lp+1) == '*') return COMMENT_S;
    if (*lp == '*' && *(lp+1) == '/') return COMMENT_E;
    if (*lp == '"' || *lp == '\'') return QUOTE;
    if ((*lp >= 'A' && *lp <= 'Z') ||
	(*lp >= 'a' && *lp <= 'z') ||
	*lp == '_') return ALPHA;
    if (*lp >= '0' && *lp <= '9') return NUMERIC;

    if (*lp == '<' && *(lp+1) == '.')	return FIELD_L;
    if (*lp == '^' && *(lp+1) == '.')	return FIELD_C;
    if (*lp == '>' && *(lp+1) == '.')	return FIELD_R;

    return OTHER;
    }

nxt(show) {
    if (show) fputc(*lp,ofp);
    lp++;
    while (!*lp) getline(1);
    }

dowhite(after) {
    int	    t;

    wp = wspace;
    if (after) {
	while (*lp && (t=typ()) == WHITE) {
	    *wp++ = *lp++;
	    if (!*lp) getline(0);
	    }
	}
    else {
	while ((t=typ()) == WHITE) nxt(1);
	}
    *wp = '\0';
    return t;
    }

gettoken(show) {
    int	    t,clevel = 0;
    char    *tp = token,chr;

    if (show) {
	fputs(token,ofp);
	if (wp != wspace) {
	    fputs(wspace,ofp);
	    wp = wspace;
	    }
	}
    while (1) {
	switch (t = dowhite(0)) {
	    case COMMENT_S:
	    clevel++;
	    nxt(1);
	    nxt(1);
	    while (clevel) {
		if ((t=typ()) == COMMENT_E) { nxt(1); clevel--; }
		if (t == COMMENT_S)	    { nxt(1); clevel++; }
		nxt(1);
		}
	    break;

	    case COMMENT_E:
	    leave("Extra closing comment");
	    break;

	    case QUOTE:
	    chr = *lp;
	    nxt(1);
	    while (typ() != QUOTE || *lp != chr) {
		if (*lp == '\\') {
		    nxt(1);
		    if (typ() == NUMERIC)
			while (typ() == NUMERIC) nxt(1);
		    else nxt(1);
		    }
		else nxt(1);
		}
	    nxt(1);
	    break;

	    case ALPHA:
	    *tp++ = *lp; 
	    nxt(0);
	    while (typ() == ALPHA || typ() == NUMERIC) {
		*tp++ = *lp;
		nxt(0);
		}
	    *tp = '\0';
	    toktyp = ALPHA;
	    dowhite(1);
	    return;

	    case NUMERIC:
	    while (typ() == NUMERIC) nxt(1);
	    break;

	    case FIELD_L:
	    case FIELD_C:
	    case FIELD_R:
	    *tp++  = *lp; nxt(0);
	    *tp++  = *lp; nxt(0);
	    *tp    = '\0';
	    toktyp = t;
	    dowhite(1);
	    return;

	    case OTHER:
	    *tp++ = *lp;
	    nxt(0);
	    *tp = '\0';
	    toktyp = OTHER;
	    dowhite(1);
	    return;
	    }
	}
    }

match(name)
char	*name;
    {
    if (toktyp == OTHER) {
	if (name[0] != token[0]) return 0;
	}
    else if (strcmp(name,token)) return 0;
    strcpy(prev,wspace);
    gettoken(0);
    return 1;
    }

field() {
    if (toktyp != FIELD_L &&
	toktyp != FIELD_R &&
	toktyp != FIELD_C) return 0;
    ftyp = toktyp;
    gettoken(0);
    return 1;
    }

id() {
    if (toktyp != ALPHA) return 0;
    strcpy(idname,token);
    strcpy(prev,wspace);
    gettoken(0);
    return 1;
    }

doexpr() {
    while (!match(";")) {
	if (!field()) {
	    gettoken(1);
	    continue;
	    }
	if (!id()) leave("Expected NAME after >. ^. or <.");
	switch (ftyp) {
	    case FIELD_L:
	    fprintf(ofp,"NC_u1->%s",idname);
	    break;

	    case FIELD_C:
	    switch (wtyp) {
		case 0:	leave(" can't use ^. in this WITH statement");
		case 1:	fprintf(ofp,"NC_l1->%s",idname); break;
		case 2:	fprintf(ofp,"NC_l1->%s",idname); break;
		case 3:	leave(" can't use :- in this WITH statement");
		}
	    break;

	    case FIELD_R:
	    switch (wtyp) {
		case 0:	leave(" can't use >. in this WITH statement");
		case 1:	fprintf(ofp,"NC_l1->inp->%s",idname); break;
		case 2:	fprintf(ofp,"NC_l1->out->%s",idname); break;
		case 3:	fprintf(ofp,"NC_u2->%s",idname); break;
		}
	    break;
	    }
	fputs(prev,ofp);
	}
    fputc(';',ofp);
    fputs(prev,ofp);
    }

main(argc,argv)
char	**argv;
    {
    int	    parens;
    char    *nam;

    if (argc < 2) leave("Must supply an input file name");
    ifp = fopen((nam=defaultext(argv[1],".nc",0)),"r");
    if (!ifp) leave("Can't open input file %s",nam);
    ofp = fopen((nam=defaultext(argv[1],".c",1)),"w");
    if (!ofp) leave("Can't open ouitput file %s",nam);

    line[0] = ' ';
    getline();

    while (1) {
	while (!match("with")) gettoken(1);
	fputs("for",ofp);
	fputs(prev,ofp);
	if (!match("(")) leave("Expected open parenthesis after with");
	fputs("(NC_u1 = networks[",ofp);
	while (1) {
	    if (match(")")) {
		wtyp = 0;
		break;
		}
	    if (match(";")) {
		if (match("INPUTS"))	{ wtyp = 1; break; }
		if (match("OUTPUTS"))	{ wtyp = 2; break; }
		wtyp = 3; break;
		}
	    gettoken(1);
	    }
	if ((wtyp == 1 || wtyp == 2) && !match(")"))
	    leave("Expected close parenthesis after INPUTS/OUTPUTS");
	if (wtyp != 3) {
	    fputs("]; NC_u1; NC_u1 = NC_u1->next)",ofp);
	    if (wtyp == 1) 
		fputs(
		    "\n\t    for (NC_l1=NC_u1->inp; NC_l1; NC_l1=NC_l1->inpnxt)",
		    ofp);
	    if (wtyp == 2) 
		fputs(
		    "\n\t    for (NC_l1=NC_u1->out; NC_l1; NC_l1=NC_l1->outnxt)",
		    ofp);
	    }
	else {
	    fputs("], NC_u2 = networks[",ofp);
	    while (1) {
		if (match(")")) break;
		gettoken(1);
		}
	    fputs("];\n",ofp);
	    fputs("\t    NC_u1 && NC_u2;\n",ofp);
	    fputs("\t    NC_u1 = NC_u1->next,NC_u2 = NC_u2->next)",ofp);
	    }
	fputs(prev,ofp);
	if (match("{")) {
	    fputs("{",ofp);
	    fputs(prev,ofp);
	    parens = 1;
	    while (parens) {
		doexpr();
		if (match("{")) { 
		    fputs("{",ofp);
		    fputs(prev,ofp);
		    parens++; 
		    }
		if (match("}")) { 
		    fputs("}",ofp);
		    fputs(prev,ofp);
		    parens--;
		    }
		}
	    }
	else doexpr();
	}
    }
